      SUBROUTINE REC_TO_REAL_(A_CELL,B_CELL,C_CELL,ALP,BET,GAM,VOL,
     1     A_STAR,B_STAR,C_STAR,VOL_STAR,ALP_STAR,BET_STAR,GAM_STAR)
      REAL*4  A_CELL, B_CELL, C_CELL, ALP, BET, GAM, VOL
      REAL*4  A_STAR, B_STAR, C_STAR, VOL_STAR
      REAL*4  ALP_STAR, BET_STAR, GAM_STAR
      CALL REC_TO_REAL (A_CELL,B_CELL,C_CELL,ALP,BET,GAM,VOL,
     1     A_STAR,B_STAR,C_STAR,VOL_STAR,ALP_STAR,BET_STAR,GAM_STAR)
      END SUBROUTINE REC_TO_REAL_



      SUBROUTINE R4_IMG_SYM_(IMG1, NCOL, NROW, XCEN, YCEN, NROT,
     1     IMG_MIN, IMG_MAX, IMG_AVG, IMG_STD, IMG_BKG, rint, numAlloc)
      INTEGER*4 NROT, NCOL, NROW, numAlloc
      REAL*4    IMG_AVG, IMG_STD, XCEN, YCEN
      real*4    IMG_MIN, IMG_MAX, IMG_BKG
      real*4    IMG1(1), rint(numAlloc)
      CALL R4_IMG_SYM(IMG1, NCOL, NROW, XCEN, YCEN, NROT,
     1     IMG_MIN, IMG_MAX, IMG_AVG, IMG_STD, IMG_BKG, rint, numAlloc)
      END SUBROUTINE R4_IMG_SYM_


      SUBROUTINE MAP_SCALE_(LUN, MAP, NCOL, NROW, NSEC, MIN_OLD,
     1     MAX_OLD, MIN_NEW, MAX_NEW, MAP_MIN, MAP_MAX, 
     2     MAP_AVG, MAP_STD, MAP_SCALEF, FILE_ID, MAP_INCORE)
      INTEGER*4 NCOL, NROW, NSEC, LUN, FILE_ID
      REAL*4    MAP(1), MIN_OLD, MAX_OLD, MIN_NEW, MAX_NEW
      REAL*4    MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD, MAP_SCALEF
      CALL MAP_SCALE(LUN, MAP, NCOL, NROW, NSEC, MIN_OLD,
     1     MAX_OLD, MIN_NEW, MAX_NEW, MAP_MIN, MAP_MAX, 
     2     MAP_AVG, MAP_STD, MAP_SCALEF, FILE_ID, MAP_INCORE)
      END SUBROUTINE MAP_SCALE_


      SUBROUTINE MAP_ROT_(MAP1, NCOL, NROW, NSEC, RANGL, AXIS)
      INTEGER*4 NCOL, NROW, NSEC
      REAL*4    MAP1(NCOL, NROW, NSEC), RANGL
      CHARACTER AXIS*1
      CALL MAP_ROT(MAP1, NCOL, NROW, NSEC, RANGL, AXIS)
      END SUBROUTINE MAP_ROT_

      SUBROUTINE PEAK_CHK_(PEAKS, NPEAK, NPEAK_UNIQUE, D)
      INTEGER*4 NPEAK, NPEAK_UNIQUE
      REAL*4    PEAKS(3,NPEAK), D
      CALL PEAK_CHK(PEAKS, NPEAK, NPEAK_UNIQUE, D)
      END SUBROUTINE PEAK_CHK_

      SUBROUTINE PEAK_CEN_(PEAKS, NPEAK, IMG, NCOL, NROW)
      INTEGER*4 NCOL, NROW, NPEAK
      REAL*4    PEAKS(3,NPEAK)
      REAL*4    IMG(NCOL,NROW)
      CALL PEAK_CEN(PEAKS, NPEAK, IMG, NCOL, NROW)
      END SUBROUTINE PEAK_CEN_

      SUBROUTINE PEAK_SORT_HI_(PEAKS, NPEAK)
      INTEGER*4 NPEAK
      REAL*4    PEAKS(3,NPEAK)
      CALL PEAK_SORT_HI(PEAKS, NPEAK)
      END SUBROUTINE PEAK_SORT_HI_


      SUBROUTINE GAUSS_LOAD_(GAUSS, NUM_ELEMENTS)
      INTEGER*4 NUM_ELEMENTS
      REAL*4    GAUSS(NUM_ELEMENTS)
      CALL GAUSS_LOAD(GAUSS, NUM_ELEMENTS)
      END SUBROUTINE GAUSS_LOAD_

      SUBROUTINE FFT_PSHIFT_(FFT, IDIM1, IDIM2, X_SHIFT, Y_SHIFT,
     1     FFT_FULL)
      INTEGER*4 IDIM1, IDIM2
      REAL*4    X_SHIFT, Y_SHIFT
      REAL*4    FFT(1)
      LOGICAL   FFT_FULL
      call FFT_PSHIFT(FFT, IDIM1, IDIM2, X_SHIFT, Y_SHIFT, FFT_FULL)
      end SUBROUTINE FFT_PSHIFT_


      SUBROUTINE COMPUTE_SCALING_(MAP, MAP2, NCOL1, NROW1, NSEC1, 
     1     TBCCOEF, NCOL2, NROW2, NSEC2, NFIT, CNTR1, CNTR2, LPOL, 
     2     MAP_STD, XC,YC,ZC,RADLO,RADHI,RADSTEP,BMAG,
     3     ccoef,nbins, BB, AA, win_size, threshValue, useAbs)
     
      INTEGER*4 NBINS
      INTEGER*4 WIN_SIZE, useAbs
      INTEGER*4 NCOL1, NROW1, NSEC1, NCOL2, NROW2, NSEC2
      INTEGER*4 LPOL, NFIT
      REAL*4    MAP(NCOL1,NROW1,NSEC1),A,B,RADSTEP
      REAL*4    MAP2(NCOL2,NROW2,NSEC2), TBCCOEF
      REAL*4    CNTR1(NFIT), CNTR2(NFIT), MAG, MAP_STD
      REAL*4    RADLO,RADHI,XC,YC,ZC
      REAL*4    CCOEF(nbins), threshValue
      REAL*4    AA, BB, BMAG

      call COMPUTE_SCALING(MAP, MAP2, NCOL1, NROW1, NSEC1, 
     1     TBCCOEF, NCOL2, NROW2, NSEC2, NFIT, CNTR1, CNTR2, LPOL, 
     2     MAP_STD, XC,YC,ZC,RADLO,RADHI,RADSTEP,BMAG,
     3     ccoef,nbins, BB, AA, win_size, threshValue, useAbs)
      end SUBROUTINE COMPUTE_SCALING_


      SUBROUTINE FFT_COPY1_(FFT2, FFT1, IDIM1, IDIM2)
      INTEGER*4 IDIM1, IDIM2
      REAL*4  FFT1(2*IDIM1,((IDIM2/2)+1)), FFT2(2*IDIM1,IDIM2)
      call FFT_COPY1(FFT2, FFT1, IDIM1, IDIM2)
      end SUBROUTINE FFT_COPY1_


      SUBROUTINE FFT_2DBT_R4_(FFT, IDIM1, IDIM2, MAP, NCOL, NROW,
     $     FFT_FULL, IMG_BKG)
      INTEGER*4 IDIM1, IDIM2, NCOL, NROW
      real*4    IMG_BKG
      REAL*4    FFT(2*IDIM1,IDIM2), MAP(NCOL,NROW)
      LOGICAL   FFT_FULL
      call FFT_2DBT_R4(FFT, IDIM1, IDIM2, MAP, NCOL, NROW,
     $     FFT_FULL, IMG_BKG)
      end SUBROUTINE FFT_2DBT_R4_

      SUBROUTINE CC_3D_(MAP, MAP2, NCOL1, NROW1, NSEC1, NCOL2, NROW2,
     $     NSEC2, ICHC, STD, xc, yc, zc, mag_cen, mag_step, mag_num,
     $     radlo, radhi, radstep, bmag, iix, iiy, iiz, mags,
     $     coefs ,subMap2d3d, qtr_switch)

      INTEGER*4 NCOL1, NROW1, NSEC1, NCOL2, NROW2, NSEC2
      INTEGER*4 MAG_NUM, NMAG, IIX, IIY, IIZ, NBINS, BIN
      INTEGER*4 subMap2d3d, ichc
      REAL*4    MAG, MAG_CEN, MAG_STEP
      REAL*4    RADLO, RADHI, radstep, XC, YC, ZC
      REAL*4    MAP(NCOL1,NROW1,NSEC1)
      real*4    mags(mag_num), coefs(mag_num)
      REAL*4    MAP2(NCOL2,NROW2,NSEC2)
      end subroutine cc_3d_


      SUBROUTINE CTF_ASTIG_(FOCUS, FOCUS_MAJ, FOCUS_MIN, PSI, PHI)
      REAL*4    FOCUS, FOCUS_MAJ, FOCUS_MIN, PSI, PHI, ANG
      call CTF_ASTIG(FOCUS, FOCUS_MAJ, FOCUS_MIN, PSI, PHI)
      end subroutine ctf_astig_

      SUBROUTINE CTF_DIVIDE_(CTFMODE, FILTER, FFT, IDIM1, IDIM2, UNITS,
     $     PIXSIZE, PI, RADIAN, WAVELENGTH, FOCUS_MAJ, FOCUS_MIN,
     $     ANG_MAJ, AMP_FAC, Cs, FILT_FAC, TFAC, FFT_FULL, Cc, BETA, dE,
     $     VOLTS)
      INTEGER*4 CTFMODE, IDIM1, IDIM2, FILTER
      INTEGER*4 UNITS
      REAL*4    FFT(1), PIXSIZE
      REAL*4    FOCUS, FOCUS_MAJ, FOCUS_MIN, ANG_MAJ, TFAC
      REAL*4    PI, RADIAN, WAVELENGTH, AMP_FAC, Cs
      REAL*4    Cc, BETA, dE, VOLTS, FILT_FAC(10)
      LOGICAL   FFT_FULL
      call CTF_DIVIDE(CTFMODE, FILTER, FFT, IDIM1, IDIM2, UNITS,
     $     PIXSIZE, PI, RADIAN, WAVELENGTH, FOCUS_MAJ, FOCUS_MIN,
     $     ANG_MAJ, AMP_FAC, Cs, FILT_FAC, TFAC, FFT_FULL, Cc, BETA, dE,
     $     VOLTS)
      end subroutine ctf_divide_

      SUBROUTINE CTF_MULTIPLY_(CTFMODE, FFT, IDIM1, IDIM2, UNITS,
     $     PIXSIZE, PI, RADIAN, WAVELENGTH, FOCUS_MAJ, FOCUS_MIN,
     $     ANG_MAJ, AMP_FAC, Cs, Cc, BETA, dE, VOLTS, TEMPFAC, FFT_FULL)
      INTEGER*4 IDIM1, IDIM2
      INTEGER*4 UNITS, CTFMODE
      REAL*4    FFT(1), PIXSIZE
      REAL*4    FOCUS_MAJ, FOCUS_MIN, ANG_MAJ
      REAL*4    PI, RADIAN, WAVELENGTH, AMP_FAC, Cs
      REAL*4    TEMPFAC, Cc, BETA, dE, VOLTS
      LOGICAL   FFT_FULL
      call CTF_MULTIPLY(CTFMODE, FFT, IDIM1, IDIM2, UNITS,
     $     PIXSIZE, PI, RADIAN, WAVELENGTH, FOCUS_MAJ, FOCUS_MIN,
     $     ANG_MAJ, AMP_FAC, Cs, Cc, BETA, dE, VOLTS, TEMPFAC, FFT_FULL)
      end subroutine ctf_multiply_

      SUBROUTINE CTF_FIRSTPEAK_WEI_(defocus, wavelength1, fft_rad,
     $     pixel_size,IDIM1, Cs, pi, units, amp_fac)
      integer*4 idim1, idim2, units
      real*4  defocus, pi, pixel_size, wavelength1
      real*4  fft_rad, Cs
      real*4  amp_fac
      call CTF_FIRSTPEAK_WEI(defocus, wavelength1, fft_rad,
     $     pixel_size,IDIM1, Cs, pi, units, amp_fac)
      end subroutine ctf_firstpeak_wei_

